
var Macarona = Macarona || {};
Macarona.ModData = Macarona.ModData || {};

(function($) {

    $.fileCheck = function() {
        const fs = require('fs');
        const path = require("path");
        const base = path.dirname(process.mainModule.filename);
        if (!fs.existsSync(`${base}/save/modsavedata.LUCILLE`)) {
            fs.writeFileSync(`${base}/save/modsavedata.LUCILLE`, JSON.stringify({
                dialogue_count: [],
                support_count: 0
            }));
        };
    }
    
    $.addData = function(parameter) {
        Macarona.ModData.fileCheck();
        const fs = require('fs');
        const path = require("path");
        const base = path.dirname(process.mainModule.filename);
        let data = JSON.parse(fs.readFileSync(`${base}/save/modsavedata.LUCILLE`, "utf-8"));
        data[parameter] = false;
        data = Object.assign({}, data, data[parameter]);
        fs.writeFileSync(`${base}/save/modsavedata.LUCILLE`, JSON.stringify(data, null, 2));
    }

    $.writeData = function(parameter, value) {
        Macarona.ModData.fileCheck();
        const fs = require('fs');
        const path = require("path");
        const base = path.dirname(process.mainModule.filename);
        let data = JSON.parse(fs.readFileSync(`${base}/save/modsavedata.LUCILLE`, "utf-8"));
        if (!data[parameter]) {
            Macarona.ModData.addData(parameter);
        };
        data[parameter] = value;
        fs.writeFileSync(`${base}/save/modsavedata.LUCILLE`, JSON.stringify(data, null, 2));
    };

    $.readData = function(parameter) {
        const fs = require('fs');
        const path = require("path");
        const base = path.dirname(process.mainModule.filename);

        let data = JSON.parse(fs.readFileSync(`${base}/save/modsavedata.LUCILLE`, "utf-8"));
        if (!data[parameter]) {
            return false;
        } else {
            return data[parameter];
        };
    };

    $.addToData = function(parameter, amount) {
        Macarona.ModData.writeData(parameter, Macarona.ModData.readData(parameter) + amount);
    };

    $.pushDialogueChoice = function(dialogue) {
        Macarona.ModData.fileCheck();
        let dialogueArray = Macarona.ModData.readData("dialogue_count");
        if (typeof dialogueArray !== "object") {
            dialogueArray = [];
        }
        if (!dialogueArray.contains(dialogue)) {
            dialogueArray.push(dialogue);
            Macarona.ModData.writeData("dialogue_count", dialogueArray);
        }
    }

})(Macarona.ModData);


